Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/SelfTest/src/test.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/SelfTest/src/test.cpp	(revision 53)
@@ -0,0 +1,237 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test
+ */
+
+#include "Behavioural/Generic/RegisterFile/SelfTest/include/test.h"
+#include "Common/include/Test.h"
+
+#define NB_ITERATION  1
+#define CYCLE_MAX     (256*NB_ITERATION)
+
+#define LABEL(str)                                                                       \
+{                                                                                        \
+  cout << "{"+toString(static_cast<uint32_t>(sc_simulation_time()))+"} " << str << endl; \
+} while(0)
+
+#define SC_START(cycle)                                        \
+do                                                             \
+{                                                              \
+  if (static_cast<uint32_t>(sc_simulation_time()) > CYCLE_MAX) \
+    {                                                          \
+      TEST_KO("Maximal cycles Reached");                       \
+    }                                                          \
+  sc_start(cycle);                                             \
+} while(0)
+
+void test (string name,
+	   morpheo::behavioural::generic::registerfile::Parameters * _param)
+{
+  cout << "<" << name << "> : Simulation SystemC" << endl;
+
+  RegisterFile * _RegisterFile = new RegisterFile (name.c_str(),
+#ifdef STATISTICS
+					     morpheo::behavioural::Parameters_Statistics(5,50),
+#endif
+					     *_param);
+  
+#ifdef SYSTEMC
+  /*********************************************************************
+   * Déclarations des signaux
+   *********************************************************************/
+  sc_clock                               * CLOCK;
+  sc_signal<Tcontrol_t>                  * NRESET;
+
+  sc_signal<Tcontrol_t>                    READ_VAL      [_param->_nb_port_read];
+  sc_signal<Tcontrol_t>                    READ_ACK      [_param->_nb_port_read];
+  sc_signal<Taddress_t>                    READ_ADDRESS  [_param->_nb_port_read];
+  sc_signal<Tdata_t>                       READ_DATA     [_param->_nb_port_read];
+
+  sc_signal<Tcontrol_t>                    WRITE_VAL     [_param->_nb_port_write];
+  sc_signal<Tcontrol_t>                    WRITE_ACK     [_param->_nb_port_write];
+  sc_signal<Taddress_t>                    WRITE_ADDRESS [_param->_nb_port_write];
+  sc_signal<Tdata_t>                       WRITE_DATA    [_param->_nb_port_write];
+
+  string rename;
+
+  CLOCK                                  = new sc_clock ("clock", 1.0, 0.5);
+  NRESET                                 = new sc_signal<Tcontrol_t> ("NRESET");
+  
+  /********************************************************
+   * Instanciation
+   ********************************************************/
+  
+  cout << "<" << name << "> Instanciation of _RegisterFile" << endl;
+  
+  (*(_RegisterFile->in_CLOCK))        (*(CLOCK));
+  (*(_RegisterFile->in_NRESET))       (*(NRESET));
+
+  for (uint32_t i=0; i<_param->_nb_port_read; i++)
+    {
+      (*(_RegisterFile-> in_READ_VAL      [i]))        (READ_VAL      [i]);
+      (*(_RegisterFile->out_READ_ACK      [i]))        (READ_ACK      [i]);
+      (*(_RegisterFile-> in_READ_ADDRESS  [i]))        (READ_ADDRESS  [i]);
+      (*(_RegisterFile->out_READ_DATA     [i]))        (READ_DATA     [i]);
+    }
+
+  for (uint32_t i=0; i<_param->_nb_port_write; i++)
+    {
+      (*(_RegisterFile-> in_WRITE_VAL     [i]))        (WRITE_VAL     [i]);
+      (*(_RegisterFile->out_WRITE_ACK     [i]))        (WRITE_ACK     [i]);
+      (*(_RegisterFile-> in_WRITE_ADDRESS [i]))        (WRITE_ADDRESS [i]);
+      (*(_RegisterFile-> in_WRITE_DATA    [i]))        (WRITE_DATA    [i]);
+    }
+
+  cout << "<" << name << "> Start Simulation ............" << endl;
+  Time * _time = new Time();
+
+  /********************************************************
+   * Simulation - Begin
+   ********************************************************/
+
+  const bool     simulate_read = true;
+  const uint32_t nb_request    = _param->_nb_word;
+  // random init
+  const uint32_t grain         = 0;
+  //const uint32_t grain = static_cast<uint32_t>(time(NULL));
+  
+  srand(grain);
+
+  // Initialisation
+
+  SC_START(0);
+  
+  for (uint32_t i=0; i<_param->_nb_port_write; i++)
+    WRITE_VAL [i] .write (0);
+
+  for (uint32_t i=0; i<_param->_nb_port_read; i++)
+    READ_VAL  [i] .write (0);
+
+  NRESET->write(0);
+
+  SC_START(5);
+
+  NRESET->write(1);
+
+  for (uint32_t nb_iteration=0; nb_iteration < NB_ITERATION; nb_iteration ++)
+    {
+      cout << "<" << name << "> 1) Write the RegisterFile (no read)" << endl;
+
+      Taddress_t nb_val            = 0;
+      Taddress_t nb_ack            = 0;
+      
+      Tdata_t    tab_data    [_param->_nb_word];
+      Taddress_t tab_address [nb_request      ];
+  
+      for (uint32_t i=0; i<_param->_nb_word; i++)
+	tab_data    [i]= rand()%(1<<(_param->_size_word-1));
+      for (uint32_t i=0; i<nb_request; i++)
+	tab_address [i]= rand()%(1<<(_param->_size_address));
+
+      while (nb_ack < nb_request)
+	{
+	  cout << "cycle : " << static_cast<uint32_t> (sc_simulation_time()) << endl;
+
+	  for (uint32_t num_port=0; num_port < _param->_nb_port_write; num_port ++)
+	    {
+	      if ((nb_val            < nb_request) and
+		  (WRITE_VAL [num_port].read() == 0))
+		{
+		  cout << "(" << num_port << ") [" << tab_address[nb_val] << "] <= " << tab_data[tab_address[nb_val]] << endl;
+		  
+		  WRITE_VAL     [num_port] .write(1);
+		  WRITE_DATA    [num_port] .write(tab_data[tab_address[nb_val]]);
+		  WRITE_ADDRESS [num_port] .write(tab_address[nb_val]);
+
+		  nb_val ++;
+
+		  // Address can be not a multiple of nb_port_write
+		  if (nb_val >= nb_request)
+		    break;
+		}
+	    }
+	  
+	  SC_START(1);
+
+	  // reset write_val port
+	  for (uint32_t num_port=0; num_port < _param->_nb_port_write; num_port ++)
+	    {
+	      if ((WRITE_ACK [num_port].read() == 1) and
+		  (WRITE_VAL [num_port].read() == 1))
+		{
+		  WRITE_VAL  [num_port] .write(0);
+		  nb_ack ++;
+		}
+	    }
+
+	  SC_START(0);
+	}
+      
+
+      if (simulate_read == true)
+	{
+	  cout << "<" << name << "> 2) Read the RegisterFile (no write)" << endl;
+	  
+	  nb_val = 0;
+	  nb_ack = 0;
+	  Tdata_t read_address [_param->_nb_port_read];
+
+	  while (nb_ack < nb_request)
+	    {
+	      cout << "cycle : " << static_cast<uint32_t> (sc_simulation_time()) << endl;
+	      
+	      for (uint32_t num_port=0; num_port < _param->_nb_port_read; num_port ++)
+		{
+		  if ((nb_val < nb_request) and
+		      (READ_VAL [num_port].read() == 0))
+		    {
+		      read_address [num_port] = tab_address[nb_val];
+		      READ_VAL     [num_port].write(1);
+		      READ_ADDRESS [num_port].write(read_address [num_port]);
+		      
+		      nb_val ++;
+		      
+		      if (nb_val >= nb_request)
+			break;
+		    }
+		}
+	      
+	      SC_START(1);
+	      
+	      // reset write_val port
+	      for (uint32_t num_port=0; num_port < _param->_nb_port_read; num_port ++)
+		{
+		  if ((READ_ACK [num_port].read() == 1) and
+		      (READ_VAL [num_port].read() == 1))
+		    {
+		      READ_VAL  [num_port] .write(0);
+		      
+		      cout << "(" << num_port << ") [" << read_address [num_port] << "] => " << READ_DATA [num_port].read() << endl;
+		      
+		      TEST(Tdata_t,READ_DATA [num_port].read(), tab_data[read_address [num_port]]);
+		      nb_ack ++;
+		    }
+		}
+	      
+	      SC_START(0);
+	    }
+	}
+    }
+
+  /********************************************************
+   * Simulation - End
+   ********************************************************/
+
+  TEST_OK ("End of Simulation");
+  delete _time;
+  cout << "<" << name << "> ............ Stop Simulation" << endl;
+
+  delete CLOCK;
+  delete NRESET;
+#endif
+
+  delete _RegisterFile;
+}
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/VERSION
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/VERSION	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/VERSION	(revision 53)
@@ -0,0 +1,4 @@
+v0.6
+
+0.5 modif vhdl_port et vhdl_testbench_port -> ajout d'une macro
+0.6 ajout de la documentation
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/doc/Makefile
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/doc/Makefile	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/doc/Makefile	(revision 53)
@@ -0,0 +1,19 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ include ]------------------------------------------
+
+all				:
+				$(MAKE) all_documentation
+
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Documentation
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/include/Parameters.h	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/include/Parameters.h	(revision 53)
@@ -0,0 +1,58 @@
+#ifndef morpheo_behavioural_generic_registerfile_Parameters_h
+#define morpheo_behavioural_generic_registerfile_Parameters_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Common/include/Debug.h"
+#include "Behavioural/include/Parameters.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Parameters.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Parameters.h"
+#include <math.h>
+
+namespace morpheo {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+
+  typedef enum {instance_RegisterFile_Monolithic  ,
+		instance_RegisterFile_Multi_Banked} Tinstance_t;
+
+
+  class Parameters : public morpheo::behavioural::Parameters
+  {
+    //-----[ fields ]------------------------------------------------------------
+  public : const Tinstance_t _instance;
+  public : const uint32_t    _nb_port_read ;
+  public : const uint32_t    _nb_port_write;
+  public : const uint32_t    _nb_word      ;
+  public : const uint32_t    _size_word    ;
+  public : const uint32_t    _size_address ;
+  public : morpheo::behavioural::generic::registerfile::registerfile_monolithic  ::Parameters * _param_registerfile_monolithic;
+  public : morpheo::behavioural::generic::registerfile::registerfile_multi_banked::Parameters * _param_registerfile_multi_banked;
+    
+
+    //-----[ methods ]-----------------------------------------------------------
+  public : Parameters  (morpheo::behavioural::generic::registerfile::registerfile_monolithic  ::Parameters * param);
+  public : Parameters  (morpheo::behavioural::generic::registerfile::registerfile_multi_banked::Parameters * param);
+  public : Parameters  (Parameters & param) ;
+  public : ~Parameters () ;
+
+  public : string msg_error (void);
+
+  public :        string   print      (uint32_t depth);
+  public : friend ostream& operator<< (ostream& output_stream,
+				       morpheo::behavioural::generic::registerfile::Parameters & x);
+  };
+
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/include/RegisterFile.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/include/RegisterFile.h	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/include/RegisterFile.h	(revision 53)
@@ -0,0 +1,119 @@
+#ifndef morpheo_behavioural_generic_registerfile_RegisterFile_h
+#define morpheo_behavioural_generic_registerfile_RegisterFile_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#include <iostream>
+#include "Common/include/ToString.h"
+#include "Common/include/Debug.h"
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h"
+
+#include "Behavioural/Generic/RegisterFile/include/Parameters.h"
+#include "Behavioural/Generic/RegisterFile/include/Types.h"
+#ifdef STATISTICS
+#include "Behavioural/Generic/RegisterFile/include/Statistics.h"
+#endif
+#include "Behavioural/include/Component.h"
+#ifdef VHDL
+#include "Behavioural/include/Vhdl.h"
+#endif
+
+using namespace std;
+
+namespace morpheo {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+
+
+  class RegisterFile 
+#if SYSTEMC
+    : public sc_module
+#endif
+  {
+    // -----[ fields ]----------------------------------------------------
+    // Parameters
+  protected : const string     _name;
+
+  protected : const Parameters _param;
+//#ifdef STATISTICS
+//  protected : const morpheo::behavioural::Parameters_Statistics _param_statistics;
+//#endif
+
+  public    : Component                      * _component;
+
+#ifdef SYSTEMC
+    // ~~~~~[ Interface ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    // Interface
+  public    : SC_CLOCK                      *  in_CLOCK        ;
+  public    : SC_IN (Tcontrol_t)            *  in_NRESET       ;
+
+    // ----- Interface Read
+  public    : SC_IN       (Tcontrol_t)     **  in_READ_VAL     ;
+  public    : SC_OUT      (Tcontrol_t)     ** out_READ_ACK     ;
+  public    : SC_IN       (Taddress_t)     **  in_READ_ADDRESS ;
+  public    : SC_OUT      (Tdata_t)        ** out_READ_DATA    ;
+
+    // ----- Interface Write
+  public    : SC_IN       (Tcontrol_t)     **  in_WRITE_VAL    ;
+  public    : SC_OUT      (Tcontrol_t)     ** out_WRITE_ACK    ;
+  public    : SC_IN       (Taddress_t)     **  in_WRITE_ADDRESS;
+  public    : SC_IN       (Tdata_t)        **  in_WRITE_DATA   ;
+
+#endif
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+  protected : morpheo::behavioural::generic::registerfile::registerfile_monolithic  ::RegisterFile_Monolithic  ::RegisterFile_Monolithic   * component_RegisterFile_Monolithic  ;
+  protected : morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::RegisterFile_Multi_Banked * component_RegisterFile_Multi_Banked;
+
+    // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+    // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+    // -----[ methods ]---------------------------------------------------
+
+#ifdef SYSTEMC
+    SC_HAS_PROCESS (RegisterFile);
+#endif
+  public  :          RegisterFile              (
+#ifdef SYSTEMC
+					      sc_module_name                              name,
+#else					       
+					      string                                      name,
+#endif					       
+#ifdef STATISTICS
+					      morpheo::behavioural::Parameters_Statistics param_statistics,
+#endif
+					      Parameters                                  param );
+					       
+  public  :          RegisterFile              (Parameters param );
+  public  :          ~RegisterFile             (void);
+					       
+#ifdef SYSTEMC				       
+  private : void     allocation                (void);
+  private : void     deallocation              (void);
+#endif					       
+
+#ifdef STATISTICS
+  public  : string   statistics                (uint32_t depth);
+#endif
+  };
+
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/include/Statistics.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/include/Statistics.h	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/include/Statistics.h	(revision 53)
@@ -0,0 +1,55 @@
+#ifdef STATISTICS
+#ifndef morpheo_behavioural_generic_registerfile_Statistics_h
+#define morpheo_behavioural_generic_registerfile_Statistics_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Common/include/Debug.h"
+#include "Behavioural/include/Statistics.h"
+#include "Behavioural/include/Parameters_Statistics.h"
+//#include "Behavioural/Generic/Group/include/Statistics.h"
+#include "Behavioural/Generic/RegisterFile/include/Parameters.h"
+
+//using namespace morpheo::behavioural::generic::group;
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+
+
+  class Statistics : public morpheo::behavioural::Statistics
+  {
+    // -----[ fields ]----------------------------------------------------
+  private  : const Parameters                                   _parameters;
+
+    // -----[ methods ]---------------------------------------------------
+  public   : Statistics  (string                                      name                       ,
+			  morpheo::behavioural::Parameters_Statistics parameters_statistics      ,
+			  Parameters                                  parameters
+			  );
+//public   : Statistics  (Statistics & stat);
+  public   : ~Statistics () ;
+    
+  public   : string   print_body (uint32_t depth);
+  public   : string   print      (uint32_t depth);
+  public   : void     add        ();
+
+  public   : friend ostream& operator<< (ostream& output_stream,
+					 const Statistics & x);
+
+  };
+
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo
+
+#endif
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/include/Types.h	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/include/Types.h	(revision 53)
@@ -0,0 +1,27 @@
+#ifndef morpheo_behavioural_generic_registerfile_Type_h
+#define morpheo_behavioural_generic_registerfile_Type_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Common/include/Types.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+
+  typedef uint32_t Taddress_t;
+  typedef uint32_t Tdata_t;
+ 
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/Parameters.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/Parameters.cpp	(revision 53)
@@ -0,0 +1,76 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/include/Parameters.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+
+
+  Parameters::Parameters (morpheo::behavioural::generic::registerfile::registerfile_monolithic  ::Parameters * param) :
+    _instance          (instance_RegisterFile_Monolithic),
+    _nb_port_read      (param->_nb_port_read ),
+    _nb_port_write     (param->_nb_port_write),
+    _nb_word           (param->_nb_word      ), 
+    _size_word         (param->_size_word    ), 
+    _size_address      (param->_size_address )
+  {
+    log_printf(FUNC,RegisterFile,"Parameters","Begin");
+
+    _param_registerfile_monolithic   = param;
+    
+    test();
+
+    log_printf(FUNC,RegisterFile,"Parameters","End");
+  };
+
+  Parameters::Parameters (morpheo::behavioural::generic::registerfile::registerfile_multi_banked::Parameters * param) :
+    _instance (instance_RegisterFile_Multi_Banked),
+    _nb_port_read      (param->_nb_port_read ),
+    _nb_port_write     (param->_nb_port_write),
+    _nb_word           (param->_nb_word      ), 
+    _size_word         (param->_size_word    ), 
+    _size_address      (param->_size_address )
+  {
+    log_printf(FUNC,RegisterFile,"Parameters","Begin");
+
+    _param_registerfile_multi_banked = param;
+
+    test();
+
+    log_printf(FUNC,RegisterFile,"Parameters","End");
+  };
+  
+  Parameters::Parameters (Parameters & param):
+    _instance          (param._instance     ),
+    _nb_port_read      (param._nb_port_read ),
+    _nb_port_write     (param._nb_port_write),
+    _nb_word           (param._nb_word      ), 
+    _size_word         (param._size_word    ), 
+    _size_address      (param._size_address )
+  {
+    log_printf(FUNC,RegisterFile,"Parameters (copy)","Begin");
+
+    _param_registerfile_multi_banked = param._param_registerfile_multi_banked;
+    _param_registerfile_monolithic   = param._param_registerfile_monolithic;
+    test();
+    log_printf(FUNC,RegisterFile,"Parameters (copy)","End");
+  };
+
+  Parameters::~Parameters () 
+  {
+    log_printf(FUNC,RegisterFile,"~Parameters","Begin");
+    log_printf(FUNC,RegisterFile,"~Parameters","End");
+  };
+
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/Parameters_msg_error.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/Parameters_msg_error.cpp	(revision 53)
@@ -0,0 +1,35 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/include/Parameters.h"
+#include "Behavioural/Generic/RegisterFile/include/Types.h"
+#include <sstream>
+using namespace std;
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+
+
+  string Parameters::msg_error(void)
+  {
+    log_printf(FUNC,RegisterFile,"msg_error","Begin");
+
+    if (_instance == instance_RegisterFile_Monolithic)
+      return _param_registerfile_monolithic  ->msg_error();
+    else
+      return _param_registerfile_multi_banked->msg_error();
+    
+    log_printf(FUNC,RegisterFile,"msg_error","End");
+  };
+
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/Parameters_print.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/Parameters_print.cpp	(revision 53)
@@ -0,0 +1,49 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/include/Parameters.h"
+#include "Behavioural/include/XML.h"
+using namespace std;
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+
+
+  string Parameters::print (uint32_t depth)
+  {
+    log_printf(FUNC,RegisterFile,"print","Begin");
+
+    string _return;
+
+    if (_instance == instance_RegisterFile_Monolithic)
+      _return = _param_registerfile_monolithic  ->print(depth);
+    else
+      _return = _param_registerfile_multi_banked->print(depth);
+
+    log_printf(FUNC,RegisterFile,"print","End");
+    
+    return _return;
+  };
+
+  ostream& operator<< (ostream& output_stream ,
+		       morpheo::behavioural::generic::registerfile::Parameters & x)
+  {
+    if (x._instance == instance_RegisterFile_Monolithic)
+      output_stream << x._param_registerfile_monolithic  ->print(0);
+    else
+      output_stream << x._param_registerfile_multi_banked->print(0);
+    
+    return output_stream;
+  };
+
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile.cpp	(revision 53)
@@ -0,0 +1,59 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/include/RegisterFile.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+
+
+#ifdef SYSTEMC
+  RegisterFile::RegisterFile (sc_module_name name,
+#else
+  RegisterFile::RegisterFile (string name,
+#endif
+#ifdef STATISTICS
+			      morpheo::behavioural::Parameters_Statistics             param_statistics,
+#endif
+			      morpheo::behavioural::generic::registerfile::Parameters param ):
+			      _name              (name)
+			      ,_param            (param)
+// #ifdef STATISTICS
+// 			      ,_param_statistics (param_statistics)
+// #endif
+  {
+    log_printf(FUNC,RegisterFile,"RegisterFile","Begin");
+
+#ifdef SYSTEMC
+    log_printf(INFO,RegisterFile,"RegisterFile","Allocation");
+
+    allocation ();
+#endif
+
+    log_printf(FUNC,RegisterFile,"RegisterFile","End");
+  };
+  
+  RegisterFile::~RegisterFile (void)
+  {
+    log_printf(FUNC,RegisterFile,"~RegisterFile","Begin");
+
+#ifdef SYSTEMC
+    log_printf(INFO,RegisterFile,"~RegisterFile","Deallocation");
+
+    deallocation ();
+#endif
+
+    log_printf(FUNC,RegisterFile,"~RegisterFile","End");
+  };
+
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
